#ifndef _HAUTEURS_HPP_
#define _HAUTEURS_HPP_

// La classe qui représente le maçon aléatoire.
class hauteurs
{
private:
  int lg, ld;
  int * gauche;
  int * droite;
public:
  hauteurs(void);

  // On doit redéfinir un constructeur par copie, un destructeur et un opérateur =, car dans
  // cette classe on doit gérer la mémoire à la main.
  hauteurs(hauteurs const &X);
  ~hauteurs(void);
  hauteurs operator=(hauteurs &X);

  // Un accesseur sur les valeurs stockées dans gauche et droite.
  int operator[](int n) const;

  // Une méthode permettant de modifier le contenu des tableaux gauche et droite.
  void ajout(int n);
};


// Un constructeur qui crée des tableaux gauche et droite de taille 1, contenant la valeur 0.
hauteurs::hauteurs(void) : lg(1), ld(1), gauche(new int[1]),droite(new int[1])
{}

// Le constructeur par copie
hauteurs::hauteurs(hauteurs const &X) : lg(X.lg), ld(X.ld), gauche(new int[lg]), droite(new int[ld])
{
  for (int i=0; i<lg; i++)
	gauche[i] = X.gauche[i];

  for (int i=0; i<ld; i++)
	droite[i] = X.droite[i];
}

// Le destructeur
hauteurs::~hauteurs(void)
{
  delete [] gauche;
  delete [] droite;
}

// L'opérateur =
hauteurs hauteurs::operator=(hauteurs &X)
{
  // Si on écrit quelque chose comme X=X, il faut arrêter la fonction.
  if (this==&X)
	return *this;

  lg = X.lg;
  ld = X.ld;

  // On crée de nouveaux tableaux gauche et droite
  int *gauche = new int[lg];
  for (int i=0; i<lg; i++)
	gauche[i] = X.gauche[i];
  
  int *droite = new int[ld];
  for (int i=0; i<ld; i++)
	droite[i] = X.droite[i];
}


// L'opérateur [], qui renvoie une valeur pour tout n entier (positif ou négatif).
int hauteurs::operator[](int n) const
{
  if (n>=0 and n<ld)
	return droite[n];

  if (n<0 and n>=-lg)
	return gauche[-n-1];

  // Si l'entier est hors mémoire, on renvoie 0.
  return 0;
}


void hauteurs::ajout(int n)
{
  if (-lg<=n and n<0)
	 gauche[-n-1] ++;
  if (n>=0 and n<ld)
	 droite[n] ++;

  if (n<-lg)
	{
	  int *gauche_temp = new int[2*lg];
	  for (int i=0; i<lg; i++)
		gauche_temp[i] = gauche[i];
	  for (int i=lg; i<2*lg; i++)
		gauche_temp[i] = 0;

	  delete [] gauche;

	  gauche = gauche_temp;
	  gauche[-n-1]++;
	  lg *= 2;
	}

  if (n>=ld)
	{
	  int *droite_temp = new int[2*ld];
	  for (int i=0; i<ld; i++)
		droite_temp[i] = droite[i];
	  for (int i=ld; i<2*ld; i++)
		droite_temp[i] = 0;

	  delete [] droite;

	  droite = droite_temp;
	  droite[n]++;
	  ld *= 2;
	}
}

#endif /*hauteurs.hpp*/
